Skip to content
Start here

Create a new policy set

client.zeroTrust.cws.policySets.create(PolicySetCreateParams { account_id, name, policies, 4 more } params, RequestOptionsoptions?): PolicySet { id, created_at, exclude_workload_ids, 6 more }
POST/accounts/{account_id}/cws/policy-sets

Creates a policy set containing the specified policies and workload targets.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
ParametersExpand Collapse
params: PolicySetCreateParams { account_id, name, policies, 4 more }
account_id: string

Path param: Cloudflare account ID (32-character hexadecimal string)

maxLength32
minLength32
name: string

Body param: Name of the policy set

maxLength100
minLength1
policies: Array<Policy> | null

Body param: Policies to include with per-membership enforcement mode

policy_id: string

ID of the member policy

formatuuid
enforce?: boolean

Whether this policy should enforce when it matches. Defaults to true; false keeps the policy attached for non-enforcing evaluation.

description?: string

Body param: Optional free-form description.

maxLength1024
exclude_workload_ids?: Array<string> | null

Body param: Workload IDs that exclude matching requests. Exclusions take precedence.

include_workload_ids?: Array<string> | null

Body param: Workload IDs that include matching requests. Empty or omitted includes all requests before exclusions.

tags?: Record<string, string>

Body param: Tags to attach. Keys are limited to 256 UTF-8 bytes and values to 1024 UTF-8 bytes.

ReturnsExpand Collapse
PolicySet { id, created_at, exclude_workload_ids, 6 more }
id: string

Server-assigned UUID

formatuuid
created_at: string
formatdate-time
exclude_workload_ids: Array<string> | null

IDs of workloads that exclude matching requests. Exclusions take precedence.

include_workload_ids: Array<string> | null

IDs of workloads that include matching requests. Empty includes all requests before exclusions.

name: string

Human-readable name; unique per account

maxLength100
minLength1
policies: Array<Policy> | null

Member policies and their per-membership enforcement mode

enforce: boolean

Whether this policy should enforce when it matches. False keeps the policy attached for non-enforcing evaluation.

policy_id: string

ID of the member policy

formatuuid
tags: Record<string, string>

Tags attached to this policy set

updated_at: string
formatdate-time
description?: string

Optional free-form description.

maxLength1024

Create a new policy set

import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const policySet = await client.zeroTrust.cws.policySets.create({
  account_id: 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx',
  name: 'x',
  policies: [{ policy_id: '182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e' }],
});

console.log(policySet.id);
{
  "errors": [
    {
      "code": 0,
      "message": "message",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 0,
      "message": "message",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "created_at": "2019-12-27T18:11:19.117Z",
    "exclude_workload_ids": [
      "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
    ],
    "include_workload_ids": [
      "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
    ],
    "name": "x",
    "policies": [
      {
        "enforce": true,
        "policy_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
      }
    ],
    "tags": {
      "foo": "string"
    },
    "updated_at": "2019-12-27T18:11:19.117Z",
    "description": "description"
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 0,
      "message": "message",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 0,
      "message": "message",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "created_at": "2019-12-27T18:11:19.117Z",
    "exclude_workload_ids": [
      "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
    ],
    "include_workload_ids": [
      "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
    ],
    "name": "x",
    "policies": [
      {
        "enforce": true,
        "policy_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
      }
    ],
    "tags": {
      "foo": "string"
    },
    "updated_at": "2019-12-27T18:11:19.117Z",
    "description": "description"
  },
  "success": true
}